## harp 1.20.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
if(POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW)
endif()

project(HARP)

set(VERSION 1.20.2)
set(HARP_VERSION \"${VERSION}\")
set(CPACK_PACKAGE_VERSION ${VERSION})

# Set dynamic library version
set(LIBHARP_CURRENT 14)
set(LIBHARP_REVISION 9)
set(LIBHARP_AGE 1)
math(EXPR LIBHARP_MAJOR "${LIBHARP_CURRENT} - ${LIBHARP_AGE}")
set(LIBHARP_MINOR ${LIBHARP_AGE})

# HARP format version
set(HARP_FORMAT_VERSION_MAJOR 1)
set(HARP_FORMAT_VERSION_MINOR 0)
set(HARP_CONVENTION \"HARP-${HARP_FORMAT_VERSION_MAJOR}.${HARP_FORMAT_VERSION_MINOR}\")


# General setup
set(CMAKE_INSTALL_DEFAULT_COMPONENT_NAME core)
set(CMAKE_MODULE_PATH
  ${HARP_SOURCE_DIR}/CMakeModules
  ${CMAKE_MODULE_PATH}
  CACHE INTERNAL "Local CMake modules")
set(CMAKE_MACOSX_RPATH ON)

include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CheckTypeSize)
include(CheckCSourceCompiles)
include(TestBigEndian)
include(CMakeDependentOption)

if(NOT MSVC AND NOT CMAKE_BUILD_TYPE AND NOT CMAKE_C_FLAGS)
  set(CMAKE_C_FLAGS "-O2 -g"
      CACHE STRING "Flags used by the C compiler during all build types." FORCE)
endif(NOT MSVC AND NOT CMAKE_BUILD_TYPE AND NOT CMAKE_C_FLAGS)

# Option handling
#
option(HARP_BUILD_IDL "build IDL interface" OFF)
option(HARP_BUILD_MATLAB "build MATLAB interface" OFF)
option(HARP_BUILD_PYTHON "build Python interface" OFF)
option(HARP_BUILD_R "build R interface" OFF)
option(HARP_WITH_HDF4 "use HDF4" ON)
option(HARP_WITH_HDF5 "use HDF5" ON)
option(HARP_ENABLE_CONDA_INSTALL OFF)
set(HARP_EXPAT_NAME_MANGLE 1)
set(HARP_NETCDF_NAME_MANGLE 1)
# Note that we also add an explicit -D option for HARP_UDUNITS2_NAME_MANGLE, since the udunits2 sources do not include config.h
set(HARP_UDUNITS2_NAME_MANGLE 1)

# settings for expat
set(XML_NS 1)
set(XML_DTD 1)
set(XML_LARGE_SIZE 1)
set(XML_CONTEXT_BYTES 1024)

if(MSVC)
  # Suppress warnings from VC on deprecated POSIX names and unsafe functions
  add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE -D_CRT_SECURE_NO_WARNINGS)
endif(MSVC)

if(HARP_BUILD_PYTHON)
  find_package(PythonInterp)
  if(NOT PYTHONINTERP_FOUND)
    message(FATAL_ERROR "PYTHON interpreter not found.")
  endif(NOT PYTHONINTERP_FOUND)
  execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import sys; from distutils import sysconfig; sys.stdout.write(sysconfig.get_python_lib(1,0,prefix=''))" OUTPUT_VARIABLE PYTHON_INSTALL_DIR)
  set(HARP_PYTHON_INSTALL_DIR "${PYTHON_INSTALL_DIR}" CACHE STRING "Install location for HARP Python package")
endif()

set(BIN_PREFIX bin)
set(LIB_PREFIX lib)
set(INCLUDE_PREFIX include)
set(DOC_PREFIX share/harp/doc)
set(PYTHON_PREFIX ${HARP_PYTHON_INSTALL_DIR}/harp)
set(R_PREFIX lib/R/site-library/harp)
set(MATLAB_PREFIX lib/harp/matlab)
set(IDL_PREFIX lib/harp/idl)
set(CODADEF_PREFIX share/coda/definitions)
set(UDUNITS2_PREFIX share/harp)
if(WIN32)
  # we use a different installation directory structure on Windows
  if(HARP_ENABLE_CONDA_INSTALL)
    # all non-python/non-R components need to be installed in a Library sub-directory for Conda on Windows
    set(BIN_PREFIX Library/bin)
    set(LIB_PREFIX Library/lib)
    set(INCLUDE_PREFIX Library/include)
    set(DOC_PREFIX Library/share/harp/doc)
    set(MATLAB_PREFIX Library/lib/harp/matlab)
    set(IDL_PREFIX Library/lib/harp/idl)
    set(CODADEF_PREFIX Library/share/coda/definitions)
    set(UDUNITS2_PREFIX Library/share/harp)
  else(CODA_ENABLE_CONDA_INSTALL)
    set(DOC_PREFIX doc)
    set(PYTHON_PREFIX python/harp)
    set(R_PREFIX R/harp)
  endif(HARP_ENABLE_CONDA_INSTALL)
endif(WIN32)

SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_PREFIX}")

if(NOT MSVC)
  set(MATHLIB m)
endif(NOT MSVC)

set(INCLUDES "")

macro(find_include FILE VARIABLE)
  CHECK_INCLUDE_FILE(${FILE} ${VARIABLE})
  if(${VARIABLE})
    set(INCLUDES ${INCLUDES} ${FILE})
  endif(${VARIABLE})
endmacro(find_include)

find_include(dirent.h HAVE_DIRENT_H)
find_include(dlfcn.h HAVE_DLFCN_H)
find_include(inttypes.h HAVE_INTTYPES_H)
find_include(limits.h HAVE_LIMITS_H)
find_include(stdarg.h HAVE_STDARG_H)
find_include(stdio.h HAVE_STDIO_H)
find_include(stdint.h HAVE_STDINT_H)
find_include(stdlib.h HAVE_STDLIB_H)
find_include(string.h HAVE_STRING_H)
find_include(strings.h HAVE_STRINGS_H)
find_include(sys/stat.h HAVE_SYS_STAT_H)
find_include(sys/types.h HAVE_SYS_TYPES_H)
find_include(unistd.h HAVE_UNISTD_H)

set(CMAKE_EXTRA_INCLUDE_FILES ${INCLUDES})

check_function_exists(bcopy HAVE_BCOPY)
check_function_exists(floor HAVE_FLOOR)
check_function_exists(getpagesize HAVE_GETPAGESIZE)
check_function_exists(malloc HAVE_MALLOC)
check_function_exists(memmove HAVE_MEMMOVE)
check_function_exists(mmap HAVE_MMAP)
check_function_exists(pread HAVE_PREAD)
check_function_exists(realloc HAVE_REALLOC)
check_function_exists(stat HAVE_STAT)
check_function_exists(strcasecmp HAVE_STRCASECMP)
check_function_exists(strdup HAVE_STRDUP)
check_function_exists(strerror HAVE_STRERROR)
check_function_exists(strncasecmp HAVE_STRNCASECMP)
check_function_exists(vsnprintf HAVE_VSNPRINTF)

set(UCHAR "unsigned char")
check_symbol_exists(size_t "${INCLUDES}" HAVE_SIZE_T)
set(SIZE_T "long")
check_symbol_exists(ptrdiff_t "${INCLUDES}" HAVE_PTRDIFF_T)
set(PTRDIFF_T "int")

check_type_size(size_t SIZEOF_SIZE_T)
check_type_size(off_t SIZEOF_OFF_T)
check_type_size(double SIZEOF_DOUBLE)
check_type_size(float SIZEOF_FLOAT)
check_type_size(int SIZEOF_INT)
check_type_size(long SIZEOF_LONG)
check_type_size(short SIZEOF_SHORT)

check_type_size(_Bool SIZEOF__BOOL)
set(HAVE__BOOL ${SIZEOF__BOOL})

test_big_endian(WORDS_BIGENDIAN)

if(HAVE_STDLIB_H AND HAVE_STDDEF_H)
  set(STDC_HEADERS 1)
endif(HAVE_STDLIB_H AND HAVE_STDDEF_H)

if(MSVC AND MSVC_VERSION LESS 1600 AND NOT MINGW)
# For Visual Studio > 2010 and MinGW we can use stdint.h
# For earlier versions of Visual Studio we need to provide our own defines
set(int8_t "signed char")
set(int16_t "signed short")
set(int32_t "int")
set(int64_t "__int64")
set(uint8_t "unsigned char")
set(uint16_t "unsigned short")
set(uint32_t "unsigned int")
set(uint64_t "unsigned __int64")
endif(MSVC AND MSVC_VERSION LESS 1600 AND NOT MINGW)

find_package(BISON)
find_package(FLEX)

if(HARP_WITH_HDF4)
  find_package(HDF4)
  if(NOT HDF4_FOUND)
    message(FATAL_ERROR "HDF4 libraries and/or header files are not found. Try setting the HDF4_LIBRARY_DIR and HDF4_INCLUDE_DIR cmake variables to the location of your HDF4 library and include files.")
  else(NOT HDF4_FOUND)
    set(HAVE_HDF4 1)
    include_directories(${HDF4_INCLUDE_DIR})
  endif(NOT HDF4_FOUND)
endif(HARP_WITH_HDF4)

if(HARP_WITH_HDF5)
  find_package(HDF5)
  if(NOT HDF5_FOUND)
      message(FATAL_ERROR "HDF5 libraries and/or header files are not found. Try setting the HDF5_LIBRARY_DIR and HDF5_INCLUDE_DIR cmake variables to the location of your HDF5 library and include files.")
  else(NOT HDF5_FOUND)
    set(HAVE_HDF5 1)
    include_directories(${HDF5_INCLUDE_DIR})
  endif(NOT HDF5_FOUND)
endif(HARP_WITH_HDF5)

if(HARP_BUILD_R)
  find_package(R)
  if(NOT R_FOUND)
    message(FATAL_ERROR "R installation not found.")
  endif(NOT R_FOUND)
  include_directories(${R_INCLUDE_DIR})
endif()

# We allow HARP to be build as part of a larger CMake build that also includes
# CODA. It this is the case then CODA_SOURCE_DIR and CODA_BINARY_DIR will
# already be set and we don't have to look for an installed version of CODA.
if(DEFINED CODA_SOURCE_DIR AND DEFINED CODA_BINARY_DIR)
  set(CODA_INCLUDE_DIR ${CODA_BINARY_DIR} ${CODA_SOURCE_DIR}/libcoda)
  set(CODA_LIBRARIES coda)
else(DEFINED CODA_SOURCE_DIR AND DEFINED CODA_BINARY_DIR)
  find_package(CODA)
  if(NOT CODA_FOUND)
    message(FATAL_ERROR "CODA libraries and/or header files are not found. Try setting the CODA_LIBRARY_DIR and CODA_INCLUDE_DIR cmake variables to the location of your CODA library and include files.")
  endif(NOT CODA_FOUND)
endif(DEFINED CODA_SOURCE_DIR AND DEFINED CODA_BINARY_DIR)

include_directories(${CODA_INCLUDE_DIR})

include_directories(BEFORE ${HARP_BINARY_DIR} ${HARP_SOURCE_DIR}/libharp)

add_definitions(-DHAVE_CONFIG_H)

# The Doxyfile uses some autoconf variables CMake does not have.
# We set them here manually, so that we can use the same .in
# file for both autoconf and cmake
#
set(top_builddir ${CMAKE_BINARY_DIR})
set(top_srcdir ${CMAKE_SOURCE_DIR})
set(srcdir ${CMAKE_CURRENT_SOURCE_DIR}/doc)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile.in
  ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile)


# libharp sources
#

BISON_TARGET(harp-operation-parser ${CMAKE_CURRENT_SOURCE_DIR}/libharp/harp-operation-parser.y ${CMAKE_CURRENT_BINARY_DIR}/harp-operation-parser.c)
FLEX_TARGET(harp-operation-scanner ${CMAKE_CURRENT_SOURCE_DIR}/libharp/harp-operation-scanner.l ${CMAKE_CURRENT_BINARY_DIR}/harp-operation-scanner.c)
add_flex_bison_dependency(harp-operation-scanner harp-operation-parser)

set(LIBHARP_SOURCES
  libharp/harp-analysis.c
  libharp/harp-area-mask.h
  libharp/harp-area-mask.c
  libharp/harp-aux-afgl86.c
  libharp/harp-aux-usstd76.c
  libharp/harp-binning.c
  libharp/harp-chemistry.h
  libharp/harp-chemistry.c
  libharp/harp-collocation.c
  libharp/harp-constants.h
  libharp/harp-dataset.c
  libharp/harp-derived-variable.c
  libharp/harp-derived-variable-list.c
  libharp/harp-dimension-mask.h
  libharp/harp-dimension-mask.c
  libharp/harp-csv.h
  libharp/harp-csv.c
  libharp/harp-errno.c
  libharp/harp-filter.h
  libharp/harp-filter.c
  libharp/harp-filter-collocation.h
  libharp/harp-filter-collocation.c
  libharp/harp-geometry-sphere-euler.c
  libharp/harp-geometry-sphere-line.c
  libharp/harp-geometry-sphere-point.c
  libharp/harp-geometry-sphere-polygon.c
  libharp/harp-geometry-vector3d.c
  libharp/harp-geometry-util.c
  libharp/harp-geometry.h
  libharp/harp-ingest-ace_fts_l2.c
  libharp/harp-ingest-aeolus_l1b.c
  libharp/harp-ingest-aeolus_l2a.c
  libharp/harp-ingest-aeolus_l2b.c
  libharp/harp-ingest-calipso_l2.c
  libharp/harp-ingest-cci_l2_aerosol.c
  libharp/harp-ingest-cci_l2_ghg.c
  libharp/harp-ingest-cci_l2_o3_lp.c
  libharp/harp-ingest-cci_l2_o3_np.c
  libharp/harp-ingest-cci_l2_o3_tc.c
  libharp/harp-ingest-cci_l3_aerosol.c
  libharp/harp-ingest-cci_l3_cloud.c
  libharp/harp-ingest-cci_l3_ghg.c
  libharp/harp-ingest-cci_l3_o3_lntoc.c
  libharp/harp-ingest-cci_l3_o3_lp.c
  libharp/harp-ingest-cci_l3_o3_np.c
  libharp/harp-ingest-cci_l3_o3_tc.c
  libharp/harp-ingest-cci_l3_o3_ttoc.c
  libharp/harp-ingest-cci_l4_o3_np.c
  libharp/harp-ingest-cloudnet.c
  libharp/harp-ingest-earlinet.c
  libharp/harp-ingest-earthcare_l2.c
  libharp/harp-ingest-ecmwf-grib.c
  libharp/harp-ingest-geoms-ftir.c
  libharp/harp-ingest-geoms-lidar.c
  libharp/harp-ingest-geoms-mwr.c
  libharp/harp-ingest-geoms-pandora.c
  libharp/harp-ingest-geoms-sonde.c
  libharp/harp-ingest-geoms-tccon.c
  libharp/harp-ingest-geoms-uvvis-brewer.c
  libharp/harp-ingest-geoms-uvvis-doas.c
  libharp/harp-ingest-geoms-uvvis-dobson.c
  libharp/harp-ingest-gome_l1.c
  libharp/harp-ingest-gome_l2.c
  libharp/harp-ingest-gome2_l1.c
  libharp/harp-ingest-gome2_l2.c
  libharp/harp-ingest-gomos_l1.c
  libharp/harp-ingest-gomos_l2.c
  libharp/harp-ingest-gosat_fts_l1b.c
  libharp/harp-ingest-gosat_fts_l2.c
  libharp/harp-ingest-hirdls_l2.c
  libharp/harp-ingest-iasi_l1.c
  libharp/harp-ingest-iasi_l2.c
  libharp/harp-ingest-mipas_l1.c
  libharp/harp-ingest-mipas_l2.c
  libharp/harp-ingest-mls_l2.c
  libharp/harp-ingest-npp-suomi-crimss_l2.c
  libharp/harp-ingest-npp-suomi-omps_profiles_l2.c
  libharp/harp-ingest-npp-suomi-omps_totals_l2.c
  libharp/harp-ingest-npp-suomi-viirs_l2.c
  libharp/harp-ingest-oco-l3co2.c
  libharp/harp-ingest-oco-ltco2.c
  libharp/harp-ingest-oco-ltsif.c
  libharp/harp-ingest-omi_l2.c
  libharp/harp-ingest-omi_l3.c
  libharp/harp-ingest-osiris_l2.c
  libharp/harp-ingest-pal_s5p_l2.c
  libharp/harp-ingest-qa4ecv.c
  libharp/harp-ingest-sciamachy_l1.c
  libharp/harp-ingest-sciamachy_l2.c
  libharp/harp-ingest-s5p_l1b.c
  libharp/harp-ingest-s5p_l2.c

=== debian/changelog ===
harp (1.20.2-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:23:24 +0000

harp (1.20.2-1build1) noble; urgency=high

  * No change rebuild against libnetcdf19t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:18:00 +0100

harp (1.20.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 17 Nov 2023 12:31:13 +0000

harp (1.20.1-2) unstable; urgency=medium

  * Don't delete js files that aren't shipped in sphinx 7. Closes: #1042607

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 04 Nov 2023 14:23:26 +0000

harp (1.20.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 16 Oct 2023 08:51:27 +0100

harp (1.20-1) unstable; urgency=medium

  * New upstream release
  * Fix typo in d/copyright that broke parsing

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 28 Sep 2023 14:04:15 +0100

=== debian/control ===
Source: harp
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers  <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-sequence-python3,
 libjs-jquery, libjs-mathjax, libjs-underscore,
 dh-buildinfo,
 bison,
 zip,
 python3-all,
 python3-numpy,
 python3-breathe,
 libcoda-dev (>= 2.20-2),
 libnetcdf-dev, netcdf-bin,
 libhdf5-dev | libhdf5-serial-dev,
 libaec-dev,
 libjpeg-dev,
 zlib1g-dev,
 libhdf4-alt-dev,
 libexpat1-dev,
 libudunits2-dev,
 flex,
 sphinx-doc,
 python3-sphinx-rtd-theme,
 python3-sphinxcontrib.jquery,
 doxygen
Standards-Version: 4.6.2
Homepage: https://github.com/stcorp/harp
Vcs-Browser: https://salsa.debian.org:/science-team/harp.git
Vcs-Git: https://salsa.debian.org/science-team/harp.git -b debian/latest

Package: harp
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libharp13 ( = ${binary:Version}), libudunits2-data
Recommends: python3-harp
Description: Data harmonization toolset for Earth Observation formats
 HARP is a toolset for ingesting, processing and inter-comparing satellite or
 model data against correlative data. The toolset is composed of a set of
 command line tools, a C library of analysis functions, and import/export
 interfaces for Python. The main goal of HARP is to assist
 in the inter-comparison of data sets. By appropriatelty chaining calls to
 the HARP command line tools one can preprocess satellite, model, and/or
 correlative data such that two datasets that need to be compared end up
 having the same temporal/spatial grid, same data format/structure, and same
 physical units.
 .
 This package provides the HARP binary utilities.

Package: libharp13
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, python3-cffi-backend, python3-numpy
Multi-Arch: same
Description: Data harmonisation toolset for Earth Observation formats
 HARP is a toolset for ingesting, processing and inter-comparing satellite or
 model data against correlative data. The toolset is composed of a set of
 command line tools, a C library of analysis functions, and import/export
 interfaces for Python. The main goal of HARP is to assist
 in the inter-comparison of data sets. By appropriatelty chaining calls to
 the HARP command line tools one can preprocess satellite, model, and/or
 correlative data such that two datasets that need to be compared end up
 having the same temporal/spatial grid, same data format/structure, and same
 physical units.
 .
 This package provides the HARP shared library.

Package: libharp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libharp13 (= ${binary:Version}),
 libjs-jquery, libjs-mathjax, libjs-underscore, libjs-sphinxdoc,
 fonts-roboto-slab, fonts-lato
Description: Data harmonisation toolset for Earth Observation formats
 HARP is a toolset for ingesting, processing and inter-comparing satellite or
 model data against correlative data. The toolset is composed of a set of
 command line tools, a C library of analysis functions, and import/export
 interfaces for Python. The main goal of HARP is to assist
 in the inter-comparison of data sets. By appropriatelty chaining calls to
 the HARP command line tools one can preprocess satellite, model, and/or
 correlative data such that two datasets that need to be compared end up
 having the same temporal/spatial grid, same data format/structure, and same
 physical units.
 .
 This package provides static libs and development files for HARP.


Package: python3-harp
Architecture: any
Section: python
Depends: harp, ${misc:Depends}, ${python3:Depends},  libharp13 ( = ${binary:Version})
Provides: ${python:Provides}
Description: Python3 interface for the HARP data harmonisation toolset
 HARP is a toolset for ingesting, processing and inter-comparing satellite or
 model data against correlative data. The toolset is composed of a set of
 command line tools, a C library of analysis functions, and import/export
 interfaces for Python. The main goal of HARP is to assist
 in the inter-comparison of data sets. By appropriatelty chaining calls to
 the HARP command line tools one can preprocess satellite, model, and/or
 correlative data such that two datasets that need to be compared end up
 having the same temporal/spatial grid, same data format/structure, and same
 physical units.
 .
 This package contains Python3 wrappers for the HARP toolset.

## harp 1.22

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,17 +1,17 @@
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.12.4)
 if(POLICY CMP0075)
   cmake_policy(SET CMP0075 NEW)
 endif()
 
 project(HARP)
 
-set(VERSION 1.20.2)
+set(VERSION 1.22)
 set(HARP_VERSION \"${VERSION}\")
 set(CPACK_PACKAGE_VERSION ${VERSION})
 
 # Set dynamic library version
 set(LIBHARP_CURRENT 14)
-set(LIBHARP_REVISION 9)
+set(LIBHARP_REVISION 10)
 set(LIBHARP_AGE 1)
 math(EXPR LIBHARP_MAJOR "${LIBHARP_CURRENT} - ${LIBHARP_AGE}")
 set(LIBHARP_MINOR ${LIBHARP_AGE})
@@ -70,12 +70,11 @@
 endif(MSVC)
 
 if(HARP_BUILD_PYTHON)
-  find_package(PythonInterp)
-  if(NOT PYTHONINTERP_FOUND)
-    message(FATAL_ERROR "PYTHON interpreter not found.")
-  endif(NOT PYTHONINTERP_FOUND)
-  execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import sys; from distutils import sysconfig; sys.stdout.write(sysconfig.get_python_lib(1,0,prefix=''))" OUTPUT_VARIABLE PYTHON_INSTALL_DIR)
-  set(HARP_PYTHON_INSTALL_DIR "${PYTHON_INSTALL_DIR}" CACHE STRING "Install location for HARP Python package")
+  find_package(Python COMPONENTS Interpreter)
+  if(NOT Python_Interpreter_FOUND)
+    message(FATAL_ERROR "Python interpreter not found.")
+  endif(NOT Python_Interpreter_FOUND)
+  set(HARP_PYTHON_INSTALL_DIR "${Python_SITEARCH}" CACHE STRING "Install location for HARP Python package")
 endif()
 
 set(BIN_PREFIX bin)
@@ -350,3 +349,9 @@
   libharp/harp-ingest-sciamachy_l2.c
   libharp/harp-ingest-s5p_l1b.c
   libharp/harp-ingest-s5p_l2.c
+  libharp/harp-ingest-smr_l2.c
+  libharp/harp-ingest-temis.c
+  libharp/harp-ingest-tes_l2.c
+  libharp/harp-ingestion.h
+  libharp/harp-ingestion.c
+  libharp/harp-ingestion-doc.c

=== debian/changelog ===
harp (1.22-1) unstable; urgency=medium

  * New upstream release
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 17 Jun 2024 13:46:29 +0100

harp (1.21-2) unstable; urgency=medium

  * Patch for FTBFS (implicit fn declarations) with HDF 4.3.0.
    Thanks to Bas Couweberg. Closes: #1068385

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 04 Apr 2024 12:59:55 +0200

harp (1.21-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 16 Mar 2024 07:16:08 +0000

## harp 1.23

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,13 +5,13 @@
 
 project(HARP)
 
-set(VERSION 1.22)
+set(VERSION 1.23)
 set(HARP_VERSION \"${VERSION}\")
 set(CPACK_PACKAGE_VERSION ${VERSION})
 
 # Set dynamic library version
 set(LIBHARP_CURRENT 14)
-set(LIBHARP_REVISION 10)
+set(LIBHARP_REVISION 11)
 set(LIBHARP_AGE 1)
 math(EXPR LIBHARP_MAJOR "${LIBHARP_CURRENT} - ${LIBHARP_AGE}")
 set(LIBHARP_MINOR ${LIBHARP_AGE})

=== debian/changelog ===
harp (1.23-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 01 Aug 2024 06:18:39 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: harp
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers  <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers  <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13),
  dh-sequence-python3,
@@ -27,9 +26,9 @@
  python3-sphinx-rtd-theme,
  python3-sphinxcontrib.jquery,
  doxygen
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/stcorp/harp
-Vcs-Browser: https://salsa.debian.org:/science-team/harp.git
+Vcs-Browser: https://salsa.debian.org/science-team/harp.git
 Vcs-Git: https://salsa.debian.org/science-team/harp.git -b debian/latest
 
 Package: harp

## harp 1.24

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,13 +5,13 @@
 
 project(HARP)
 
-set(VERSION 1.23)
+set(VERSION 1.24)
 set(HARP_VERSION \"${VERSION}\")
 set(CPACK_PACKAGE_VERSION ${VERSION})
 
 # Set dynamic library version
 set(LIBHARP_CURRENT 14)
-set(LIBHARP_REVISION 11)
+set(LIBHARP_REVISION 12)
 set(LIBHARP_AGE 1)
 math(EXPR LIBHARP_MAJOR "${LIBHARP_CURRENT} - ${LIBHARP_AGE}")
 set(LIBHARP_MINOR ${LIBHARP_AGE})

=== debian/changelog ===
harp (1.24-2build1) plucky; urgency=medium

  * No-change rebuild for libnetcdf22.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 18 Feb 2025 07:58:04 +0000

harp (1.24-2) unstable; urgency=medium

  * Drop B-D on dh-buildinfo
  * Update B-D on libcoda-dev to (>= 2.25.3-2) for libcoda16 transition

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 15 Jan 2025 08:51:12 +0000

harp (1.24-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 26 Nov 2024 09:57:25 +0000

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,12 @@
 Build-Depends: debhelper-compat (= 13),
  dh-sequence-python3,
  libjs-jquery, libjs-mathjax, libjs-underscore,
- dh-buildinfo,
  bison,
  zip,
  python3-all,
  python3-numpy,
  python3-breathe,
- libcoda-dev (>= 2.20-2),
+ libcoda-dev (>= 2.25.3-2),
  libnetcdf-dev, netcdf-bin,
  libhdf5-dev | libhdf5-serial-dev,
  libaec-dev,

## harp 1.25

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,14 +5,14 @@
 
 project(HARP)
 
-set(VERSION 1.24)
+set(VERSION 1.25)
 set(HARP_VERSION \"${VERSION}\")
 set(CPACK_PACKAGE_VERSION ${VERSION})
 
 # Set dynamic library version
-set(LIBHARP_CURRENT 14)
-set(LIBHARP_REVISION 12)
-set(LIBHARP_AGE 1)
+set(LIBHARP_CURRENT 15)
+set(LIBHARP_REVISION 0)
+set(LIBHARP_AGE 2)
 math(EXPR LIBHARP_MAJOR "${LIBHARP_CURRENT} - ${LIBHARP_AGE}")
 set(LIBHARP_MINOR ${LIBHARP_AGE})
 
@@ -263,7 +263,8 @@
   libharp/harp-area-mask.c
   libharp/harp-aux-afgl86.c
   libharp/harp-aux-usstd76.c
-  libharp/harp-binning.c
+  libharp/harp-bin.c
+  libharp/harp-bin-spatial.c
   libharp/harp-chemistry.h
   libharp/harp-chemistry.c
   libharp/harp-collocation.c
@@ -308,6 +309,7 @@
   libharp/harp-ingest-cci_l4_o3_np.c
   libharp/harp-ingest-cloudnet.c
   libharp/harp-ingest-earlinet.c
+  libharp/harp-ingest-earthcare_l1.c
   libharp/harp-ingest-earthcare_l2.c
   libharp/harp-ingest-ecmwf-grib.c
   libharp/harp-ingest-geoms-ftir.c
@@ -352,6 +354,3 @@
   libharp/harp-ingest-smr_l2.c
   libharp/harp-ingest-temis.c
   libharp/harp-ingest-tes_l2.c
-  libharp/harp-ingestion.h
-  libharp/harp-ingestion.c
-  libharp/harp-ingestion-doc.c

=== debian/changelog ===
harp (1.25-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.7.2

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 21 Mar 2025 10:53:22 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: harp
 Section: utils
 Priority: optional
-Maintainer: Debian Science Maintainers  <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13),
  dh-sequence-python3,
@@ -11,7 +11,7 @@
  python3-all,
  python3-numpy,
  python3-breathe,
- libcoda-dev (>= 2.25.3-2),
+ libcoda-dev (>= 2.20-2),
  libnetcdf-dev, netcdf-bin,
  libhdf5-dev | libhdf5-serial-dev,
  libaec-dev,
@@ -25,7 +25,8 @@
  python3-sphinx-rtd-theme,
  python3-sphinxcontrib.jquery,
  doxygen
-Standards-Version: 4.7.0
+Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Homepage: https://github.com/stcorp/harp
 Vcs-Browser: https://salsa.debian.org/science-team/harp.git
 Vcs-Git: https://salsa.debian.org/science-team/harp.git -b debian/latest

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/$1\.tar\.gz/ \
  https://github.com/stcorp/harp/tags .*/(\d\S+)\.tar\.gz

## harp 1.26

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,13 +5,13 @@
 
 project(HARP)
 
-set(VERSION 1.25)
+set(VERSION 1.26)
 set(HARP_VERSION \"${VERSION}\")
 set(CPACK_PACKAGE_VERSION ${VERSION})
 
 # Set dynamic library version
 set(LIBHARP_CURRENT 15)
-set(LIBHARP_REVISION 0)
+set(LIBHARP_REVISION 1)
 set(LIBHARP_AGE 2)
 math(EXPR LIBHARP_MAJOR "${LIBHARP_CURRENT} - ${LIBHARP_AGE}")
 set(LIBHARP_MINOR ${LIBHARP_AGE})
@@ -351,6 +351,6 @@
   libharp/harp-ingest-sciamachy_l2.c
   libharp/harp-ingest-s5p_l1b.c
   libharp/harp-ingest-s5p_l2.c
+  libharp/harp-ingest-s5_l2.c
   libharp/harp-ingest-smr_l2.c
   libharp/harp-ingest-temis.c
-  libharp/harp-ingest-tes_l2.c

=== debian/changelog ===
harp (1.26-1) unstable; urgency=medium

  * New upstream release
  * implicit-function-declaration.patch merged upstream
  * lex-fix.patch: Minor patch for lex issue
  * Syntax fixes in d/copyright

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 28 Aug 2025 11:45:31 +0100

harp (1.25-2~exp1) experimental; urgency=medium

  * Use libhdf4-dev as alt is dropped. Closes: #1108653

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 03 Jul 2025 12:47:59 +0100

=== debian/control ===
--- 
+++ 
@@ -11,13 +11,13 @@
  python3-all,
  python3-numpy,
  python3-breathe,
- libcoda-dev (>= 2.20-2),
+ libcoda-dev (>= 2.25.3-2),
  libnetcdf-dev, netcdf-bin,
  libhdf5-dev | libhdf5-serial-dev,
  libaec-dev,
  libjpeg-dev,
  zlib1g-dev,
- libhdf4-alt-dev,
+ libhdf4-dev,
  libexpat1-dev,
  libudunits2-dev,
  flex,

## harp 1.27

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,13 +5,13 @@
 
 project(HARP)
 
-set(VERSION 1.26)
+set(VERSION 1.27)
 set(HARP_VERSION \"${VERSION}\")
 set(CPACK_PACKAGE_VERSION ${VERSION})
 
 # Set dynamic library version
 set(LIBHARP_CURRENT 15)
-set(LIBHARP_REVISION 1)
+set(LIBHARP_REVISION 2)
 set(LIBHARP_AGE 2)
 math(EXPR LIBHARP_MAJOR "${LIBHARP_CURRENT} - ${LIBHARP_AGE}")
 set(LIBHARP_MINOR ${LIBHARP_AGE})
@@ -332,6 +332,7 @@
   libharp/harp-ingest-hirdls_l2.c
   libharp/harp-ingest-iasi_l1.c
   libharp/harp-ingest-iasi_l2.c
+  libharp/harp-ingest-iasi-ng_l2.c
   libharp/harp-ingest-mipas_l1.c
   libharp/harp-ingest-mipas_l2.c
   libharp/harp-ingest-mls_l2.c
@@ -352,5 +353,4 @@
   libharp/harp-ingest-s5p_l1b.c
   libharp/harp-ingest-s5p_l2.c
   libharp/harp-ingest-s5_l2.c
-  libharp/harp-ingest-smr_l2.c
-  libharp/harp-ingest-temis.c
+  libharp/harp-ingest-s5_l1b.c

=== debian/changelog ===
harp (1.27-1) unstable; urgency=medium

  * New upstream release
  * Upgrade d/watch to version 4 syntax

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 15 Oct 2025 07:15:54 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  python3-all,
  python3-numpy,
  python3-breathe,
- libcoda-dev (>= 2.25.3-2),
+ libcoda-dev,
  libnetcdf-dev, netcdf-bin,
  libhdf5-dev | libhdf5-serial-dev,
  libaec-dev,

=== debian/watch ===
version=4
https://github.com/stcorp/harp/tags .*/v?(\d.*)@ARCHIVE_EXT@

## harp 1.28

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,13 +5,13 @@
 
 project(HARP)
 
-set(VERSION 1.27)
+set(VERSION 1.28)
 set(HARP_VERSION \"${VERSION}\")
 set(CPACK_PACKAGE_VERSION ${VERSION})
 
 # Set dynamic library version
 set(LIBHARP_CURRENT 15)
-set(LIBHARP_REVISION 2)
+set(LIBHARP_REVISION 3)
 set(LIBHARP_AGE 2)
 math(EXPR LIBHARP_MAJOR "${LIBHARP_CURRENT} - ${LIBHARP_AGE}")
 set(LIBHARP_MINOR ${LIBHARP_AGE})

=== debian/changelog ===
harp (1.28-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 13 Nov 2025 10:21:36 +0000

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@

DESTDIR:=`pwd`/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

# For the moment, serial hdf5 only
WITH_HDF5:=--with-hdf5=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial

override_dh_auto_configure:
	./configure --prefix=/usr --libdir=$(LIBDIR) \
		--enable-python \
		$(WITH_HDF5)  \
		HDF4_INCLUDE=/usr/include/hdf \
		UDUNITS2LIBS=-ludunits2 \
		PYTHON=python3

override_dh_auto_build:
	# rebuild docs with mathjax etc privac fix. Note it will return non-zero because of warnings
	-($(MAKE) doc || true)
	dh_auto_build

override_dh_auto_install:
	dh_auto_install
	find debian -name '*.la' -delete
	rm -f debian/tmp/usr/share/harp/doc/html/_static/jquery*
	rm -f debian/tmp/usr/share/harp/doc/html/_static/underscore*
	rm debian/tmp/usr/share/harp/doc/html/_static/doctools.js
	rm debian/tmp/usr/share/harp/doc/html/_static/language_data.js
	rm debian/tmp/usr/share/harp/doc/html/_static/searchtools.js
	rm -rf debian/tmp/usr/share/harp/doc/html/_static/fonts

## harp 1.28.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,13 +5,13 @@
 
 project(HARP)
 
-set(VERSION 1.28)
+set(VERSION 1.28.1)
 set(HARP_VERSION \"${VERSION}\")
 set(CPACK_PACKAGE_VERSION ${VERSION})
 
 # Set dynamic library version
 set(LIBHARP_CURRENT 15)
-set(LIBHARP_REVISION 3)
+set(LIBHARP_REVISION 4)
 set(LIBHARP_AGE 2)
 math(EXPR LIBHARP_MAJOR "${LIBHARP_CURRENT} - ${LIBHARP_AGE}")
 set(LIBHARP_MINOR ${LIBHARP_AGE})

=== debian/changelog ===
harp (1.28.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 17 Nov 2025 08:53:44 +0000

## harp 1.29

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,13 +5,13 @@
 
 project(HARP)
 
-set(VERSION 1.28.1)
+set(VERSION 1.29)
 set(HARP_VERSION \"${VERSION}\")
 set(CPACK_PACKAGE_VERSION ${VERSION})
 
 # Set dynamic library version
 set(LIBHARP_CURRENT 15)
-set(LIBHARP_REVISION 4)
+set(LIBHARP_REVISION 5)
 set(LIBHARP_AGE 2)
 math(EXPR LIBHARP_MAJOR "${LIBHARP_CURRENT} - ${LIBHARP_AGE}")
 set(LIBHARP_MINOR ${LIBHARP_AGE})
@@ -309,6 +309,7 @@
   libharp/harp-ingest-cci_l4_o3_np.c
   libharp/harp-ingest-cloudnet.c
   libharp/harp-ingest-earlinet.c
+  libharp/harp-ingest-earthcare_jaxa.c
   libharp/harp-ingest-earthcare_l1.c
   libharp/harp-ingest-earthcare_l2.c
   libharp/harp-ingest-ecmwf-grib.c
@@ -353,4 +354,3 @@
   libharp/harp-ingest-s5p_l1b.c
   libharp/harp-ingest-s5p_l2.c
   libharp/harp-ingest-s5_l2.c
-  libharp/harp-ingest-s5_l1b.c

=== debian/changelog ===
harp (1.29-1) unstable; urgency=medium

  * New upstream release
  * d/copyright: Updated to fix lintian recommendations, licenserecon

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 01 Dec 2025 11:55:39 +0000

## harp 1.30+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,13 +5,13 @@
 
 project(HARP)
 
-set(VERSION 1.29)
+set(VERSION 1.30)
 set(HARP_VERSION \"${VERSION}\")
 set(CPACK_PACKAGE_VERSION ${VERSION})
 
 # Set dynamic library version
 set(LIBHARP_CURRENT 15)
-set(LIBHARP_REVISION 5)
+set(LIBHARP_REVISION 6)
 set(LIBHARP_AGE 2)
 math(EXPR LIBHARP_MAJOR "${LIBHARP_CURRENT} - ${LIBHARP_AGE}")
 set(LIBHARP_MINOR ${LIBHARP_AGE})
@@ -351,6 +351,6 @@
   libharp/harp-ingest-qa4ecv.c
   libharp/harp-ingest-sciamachy_l1.c
   libharp/harp-ingest-sciamachy_l2.c
+  libharp/harp-ingest-s4_l2.c
   libharp/harp-ingest-s5p_l1b.c
   libharp/harp-ingest-s5p_l2.c
-  libharp/harp-ingest-s5_l2.c

=== debian/changelog ===
harp (1.30+ds-1) unstable; urgency=medium

  * New upstream release
  * d/watch: Move to version 5 syntax
  * Drop Priority: optional from source in d/control per new policy
  * Standards-Version: 4.7.3
  * lex-fix.patch merged upstream

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 14 Jan 2026 10:03:34 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: harp
 Section: utils
-Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13),
@@ -26,7 +25,7 @@
  python3-sphinxcontrib.jquery,
  doxygen
 Rules-Requires-Root: no
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/stcorp/harp
 Vcs-Browser: https://salsa.debian.org/science-team/harp.git
 Vcs-Git: https://salsa.debian.org/science-team/harp.git -b debian/latest

=== debian/watch ===
Version: 5
Template: GitHub
Dist: https://github.com/stcorp/harp

## harp proxy-0.9.0rc11

=== harp/commandline/cookiecutters/project/{{cookiecutter.__dir_name}}/Makefile ===
POETRY ?= $(shell which poetry || echo poetry)

.PHONY: start install test


start: install
	$(POETRY) run harp server{% if cookiecutter.create_application %} --enable {{cookiecutter.__pkg_name}}{% endif %}{% if cookiecutter.create_config %} --file config.yml{% endif %}

install:
	$(POETRY) install

test: install
	$(RUN) pytest

## harp proxy-0.10.0a2

=== harp/commandline/cookiecutters/project/{{cookiecutter.__dir_name}}/Makefile ===
########################################################################################################################
# Makefile for {{cookiecutter.name}}
########################################################################################################################

# Configuration
DEBUG ?=
HARP_OPTIONS ?=
UV ?= $(shell which uv || echo uv)

# Helper function to execute commands
define execute
@echo "⚙️ \033[36m$@\033[0m: \033[2m$(1)\033[0m"
@$(1)
endef

# Default target
.DEFAULT_GOAL := help

.PHONY: help install start test clean

help:  ## Shows this help message
	@echo "📦 \033[1m{{cookiecutter.name}}\033[0m"
	@echo
	@echo "Available commands:"
	@echo
	@grep -E '^[a-zA-Z_-]+:.*?## ' $(MAKEFILE_LIST) | awk 'BEGIN {FS = ":.*?## "}; {printf "  \033[36m%-20s\033[0m %s\n", $$1, $$2}'
	@echo

install:  ## Install dependencies using UV
	$(call execute,$(UV) sync $(if $(DEBUG),,--quiet))

start: install  ## Start the HARP proxy server
	$(call execute,$(UV) run harp-proxy server{% if cookiecutter.create_application %} --enable {{cookiecutter.__pkg_name}}{% endif %}{% if cookiecutter.create_config %} --file config.yml{% endif %} $(HARP_OPTIONS))

test: install  ## Run tests with pytest
	$(call execute,$(UV) run pytest)

clean:  ## Clean up generated files
	$(call execute,rm -rf .venv .pytest_cache __pycache__ .coverage htmlcov)
	$(call execute,find . -type d -name "*.egg-info" -exec rm -rf {} + 2>/dev/null || true)
	$(call execute,find . -type d -name "__pycache__" -exec rm -rf {} + 2>/dev/null || true)

## harp syringepump-0.1.0a1

=== Makefile ===
.PHONY: install
install: ## Install the virtual environment and install the pre-commit hooks
	@echo "🚀 Creating virtual environment using uv"
	@uv sync
	@uv run pre-commit install

.PHONY: check
check: ## Run code quality tools.
	@echo "🚀 Checking lock file consistency with 'pyproject.toml'"
	@uv lock --locked
	@echo "🚀 Linting code: Running pre-commit"
	@uv run pre-commit run -a
	@echo "🚀 Static type checking: Running mypy"
	@uv run mypy
	@echo "🚀 Checking for obsolete dependencies: Running deptry"
	@uv run deptry .

.PHONY: test
test: ## Test the code with pytest
	@echo "🚀 Testing code: Running pytest"
	@uv run python -m pytest --doctest-modules

.PHONY: build
build: clean-build ## Build wheel file
	@echo "🚀 Creating wheel file"
	@uvx --from build pyproject-build --installer uv

.PHONY: clean-build
clean-build: ## Clean build artifacts
	@echo "🚀 Removing build artifacts"
	@uv run python -c "import shutil; import os; shutil.rmtree('dist') if os.path.exists('dist') else None"

.PHONY: publish
publish: ## Publish a release to PyPI.
	@echo "🚀 Publishing."
	@uvx twine upload --repository-url https://upload.pypi.org/legacy/ dist/*

.PHONY: build-and-publish
build-and-publish: build publish ## Build and publish.

.PHONY: docs-test
docs-test: ## Test if documentation can be built without warnings or errors
	@uv run mkdocs build -s

.PHONY: docs
docs: ## Build and serve the documentation
	@uv run mkdocs serve

.PHONY: help
help:
	@uv run python -c "import re; \
	[[print(f'\033[36m{m[0]:<20}\033[0m {m[1]}') for m in re.findall(r'^([a-zA-Z_-]+):.*?## (.*)$$', open(makefile).read(), re.M)] for makefile in ('$(MAKEFILE_LIST)').strip().split()]"

.DEFAULT_GOAL := help
